unit ShowTree;


{$I ..\Parser.inc}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Menus, ParserTypes;

type
  TParseTreeForm = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Tree: TTreeView;
    PopupMenu1: TPopupMenu;
    Save1: TMenuItem;
    Font1: TMenuItem;
    N1: TMenuItem;
    FontDlg: TFontDialog;
    Expand1: TMenuItem;
    FileSaveDlg: TSaveDialog;
    Copyastexttoclipboard1: TMenuItem;
    procedure Save1Click(Sender: TObject);
    procedure Font1Click(Sender: TObject);
    procedure Expand1Click(Sender: TObject);
    procedure Copyastexttoclipboard1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    aTree: TTree;
  end;

var
  ParseTreeForm: TParseTreeForm;

implementation

{$R *.dfm}
uses
  clipbrd;


procedure TParseTreeForm.Copyastexttoclipboard1Click(Sender: TObject);
begin
  Tree.FullExpand;
  Clipboard.AsText := aTree.ToText;
end;

procedure TParseTreeForm.Expand1Click(Sender: TObject);
begin
  Tree.FullExpand;
end;

procedure TParseTreeForm.Font1Click(Sender: TObject);
begin
  with FontDlg do begin
    Font := Tree.Font;
    if execute then
      Tree.Font := font;
  end;
end;

Type
  TControlArea = (caFullArea, caClientArea);

function ControlToBitmap(Control: TWinControl; controlArea: TControlArea): TBitmap;
var
  DC: HDC;
  dx, dy: integer;
begin
  if Assigned(Control) then begin
    DC := GetWindowDC(Control.Handle);
    result := TBitmap.Create;
    if controlArea = caClientArea then begin
      result.Width  := Control.ClientWidth;
      result.Height := Control.ClientHeight;
      dx := (Control.Width - Control.ClientWidth) div 2;
      dy := (Control.height - Control.ClientHeight) div 2;
    end
    else begin
      result.Width  := Control.Width;
      result.Height := Control.Height;
      dx := 0;
      dy := 0;
    end;
    with result do
      BitBlt(Canvas.Handle, 0, 0, Width, Height, DC, dx, dy, SrcCopy);
    ReleaseDC(Control.Handle, DC);
  end;
end;

procedure TParseTreeForm.Save1Click(Sender: TObject);
var
  bm: TBitmap;
  stream: TStream;
begin
  Button1.SetFocus;
  Tree.ShowButtons := false;
  Tree.FullExpand;
  bm := nil;
  stream := nil;
  try
    with FileSaveDlg do begin
      if Filename = '' then begin
        InitialDir := extractfiledir(application.ExeName);
        Filename := changefileext(application.ExeName, '.bmp');
      end;
      if not execute then
        exit;
    end;
    stream := TFileStream.create(FileSaveDlg.filename, fmCreate);
    bm := ControlToBitmap(Tree, caClientArea);
    bm.SaveToStream(stream);
  finally
    stream.free;
    bm.free;
    Tree.ShowButtons := true;
    Tree.SetFocus;
  end;
end;

end.
