unit Table;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, ExtCtrls;

type
  TTableForm = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Bevel1: TBevel;
    Label5: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    sg: TStringGrid;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Dclarations prives }
    procedure AddToTable(Row: integer; x, fx: extended);
  public
    { Dclarations publiques }
  end;

var
  TableForm: TTableForm;

implementation

{$R *.dfm}

uses
  ParserTypes, Targets, MathParser;

var
  x: float;

type
  _x = class(TVariable)
  public
    function Calc: float; override;
  end;

function _x.Calc: float;
begin
  result := x;
end;

  {display the numbers x and fx in the string grid's row number Row}
procedure TTableForm.AddToTable(Row: integer; x, fx: extended);
begin
  if sg.RowCount < Row then
     sg.RowCount := Row;
  dec(row);
  sg.Cells[0, Row] := floattostr(x);
  sg.Cells[1, Row] := floattostr(fx);
end;

procedure TTableForm.Button1Click(Sender: TObject);
var
  firstvalue, lastvalue, step, temp: float;
  tree: TTree;
  i, maxloop: integer;
  errmsg: string;
begin
  {begin by getting x's firstvalue, lastvalue and step}
  errmsg := '';
  try
    firstvalue := EvaluateExpression(edit1.Text);
  except
    On E: Exception do
      errmsg := 'error with start value: ' + E.Message;
  end;
  try
    lastvalue := EvaluateExpression(edit2.Text);
  except
    On E: Exception do
      errmsg := 'error with end value: ' + E.Message;
  end;
  try
    step := EvaluateExpression(edit3.Text);
  except
    On E: Exception do
      errmsg := 'error with step value: ' + E.Message;
  end;
  if errmsg <> '' then begin
    MessageDlg(errmsg, mtError, [mbOK], 0);
    exit;
  end;

  {make sure that it is possible for x to get from
   firstvalue to lastvalue by adding step to x}
  if step > 0 then begin
    if firstvalue > lastvalue then begin
      temp := firstvalue;
      firstvalue := lastvalue;
      lastvalue := temp;
    end;
  end
  else if step < 0 then begin
    if firstvalue < lastvalue then begin
      temp := firstvalue;
      firstvalue := lastvalue;
      lastvalue := temp;
    end;
  end
  else begin
    MessageDlg('Step must be different from 0.', mtError, [mbOK], 0);
    exit;
  end;

  MAXLOOP := round ( (lastvalue - firstvalue) / step ) + 3;
  InternalTargets.Add('x', _x.create(@x));
  try
    tree := Parse(Edit4.Text);
    try
      sg.Cells[0,0] := 'x';
      sg.Cells[1,0] := Edit4.Text;
      x := firstValue;
      i := 2;
      while (i < MAXLOOP) do begin
        AddToTable(i, x, Tree.eval);
        inc(i);
        x := x + step;
      end;
    finally
      tree.Free;
    end;
  finally
    InternalTargets.Delete('x');
  end;
end;

procedure TTableForm.Button2Click(Sender: TObject);
var
  i,j: integer;
begin
  sg.RowCount := 2;
  for I := 0 to 1 do
    for j := 0 to 1 do
      sg.Cells[i,j] := '';
end;

end.
